config/routes.rb
Rails.application.routes.draw do
  resources :service_orders
  resources :services

  get "/service_order_report" => "service_order_report#index"
  
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/service.rb
class Service < ApplicationRecord
    validates_presence_of :description
end

app/models/service_order.rb
class ServiceOrder < ApplicationRecord
    belongs_to :service
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/service_order_report_controller.rb
class ServiceOrderReportController < ApplicationController
    def index
        @service_orders = []
        @total_sum = 0
        @final_total_sum = 0

        ServiceOrder.all.each do |os|    
            discount = 0
            
            if os.amount >= 10 && os.amount <= 30
                discount = 10 * (os.amount / 10).ceil
            end

            @total_sum += os.amount * os.service.value
            @final_total_sum += os.amount * os.service.value - (((os.amount * os.service.value)/100) * discount)

            @service_orders.push({
                "service": os.service.description,
                "value": os.service.value,
                "amount": os.amount,
                "total": os.amount * os.service.value,
                "discount": discount,
                "final_total": os.amount * os.service.value - (((os.amount * os.service.value)/100) * discount)
           })
        end
    end
end

app/controllers/service_orders_controller.rb
class ServiceOrdersController < ApplicationController
  before_action :set_service_order, only: [:show, :edit, :update, :destroy]

  # GET /service_orders
  # GET /service_orders.json
  def index
    @service_orders = ServiceOrder.all
  end

  # GET /service_orders/1
  # GET /service_orders/1.json
  def show
  end

  # GET /service_orders/new
  def new
    @service_order = ServiceOrder.new
  end

  # GET /service_orders/1/edit
  def edit
  end

  # POST /service_orders
  # POST /service_orders.json
  def create
    @service_order = ServiceOrder.new(service_order_params)

    respond_to do |format|
      if @service_order.save
        format.html { redirect_to @service_order, notice: 'Service order was successfully created.' }
        format.json { render :show, status: :created, location: @service_order }
      else
        format.html { render :new }
        format.json { render json: @service_order.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /service_orders/1
  # PATCH/PUT /service_orders/1.json
  def update
    respond_to do |format|
      if @service_order.update(service_order_params)
        format.html { redirect_to @service_order, notice: 'Service order was successfully updated.' }
        format.json { render :show, status: :ok, location: @service_order }
      else
        format.html { render :edit }
        format.json { render json: @service_order.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /service_orders/1
  # DELETE /service_orders/1.json
  def destroy
    @service_order.destroy
    respond_to do |format|
      format.html { redirect_to service_orders_url, notice: 'Service order was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_service_order
      @service_order = ServiceOrder.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def service_order_params
      params.require(:service_order).permit(:employee, :detail, :date, :start, :end, :amount, :service_id)
    end
end

app/controllers/services_controller.rb
class ServicesController < ApplicationController
  before_action :set_service, only: [:show, :edit, :update, :destroy]

  # GET /services
  # GET /services.json
  def index
    @services = Service.all
  end

  # GET /services/1
  # GET /services/1.json
  def show
  end

  # GET /services/new
  def new
    @service = Service.new
  end

  # GET /services/1/edit
  def edit
  end

  # POST /services
  # POST /services.json
  def create
    @service = Service.new(service_params)

    respond_to do |format|
      if @service.save
        format.html { redirect_to @service, notice: 'Service was successfully created.' }
        format.json { render :show, status: :created, location: @service }
      else
        format.html { render :new }
        format.json { render json: @service.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /services/1
  # PATCH/PUT /services/1.json
  def update
    respond_to do |format|
      if @service.update(service_params)
        format.html { redirect_to @service, notice: 'Service was successfully updated.' }
        format.json { render :show, status: :ok, location: @service }
      else
        format.html { render :edit }
        format.json { render json: @service.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /services/1
  # DELETE /services/1.json
  def destroy
    @service.destroy
    respond_to do |format|
      format.html { redirect_to services_url, notice: 'Service was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_service
      @service = Service.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def service_params
      params.require(:service).permit(:description, :value)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/service_order_report_helper.rb
module ServiceOrderReportHelper
end

app/helpers/service_orders_helper.rb
module ServiceOrdersHelper
end

app/helpers/services_helper.rb
module ServicesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>OsManagement</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/service_order_report/index.html.erb
<table>
    <tr>
        <th>Serviço</th>
        <th>Valor unitário</th>
        <th>Quantidade</th>
        <th>Total</th>
        <th>Desconto</th>
        <th>Valor final</th>
    </tr>
    <% @service_orders.each do |os| %>
        <tr>    
            <td><%= os[:service] %></td>
            <td><%= os[:value] %></td>
            <td><%= os[:amount] %></td>
            <td><%= os[:total] %></td>
            <td><%= os[:discount] %></td>
            <td><%= os[:final_total] %></td>
        </tr>
    <% end %>
    <tr>    
        <td><b>Total</b></td>
        <td></td>
        <td></td>
        <td><%= @total_sum %></td>
        <td></td>
        <td><%= @final_total_sum %></td>
    </tr>
</table>

app/views/service_orders/_form.html.erb
<%= form_with(model: service_order, local: true) do |form| %>
  <% if service_order.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(service_order.errors.count, "error") %> prohibited this service_order from being saved:</h2>

      <ul>
        <% service_order.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :employee %>
    <%= form.text_field :employee %>
  </div>

  <div class="field">
    <%= form.label :detail %>
    <%= form.text_field :detail %>
  </div>

  <div class="field">
    <%= form.label :date %>
    <%= form.date_select :date %>
  </div>

  <div class="field">
    <%= form.label :start %>
    <%= form.datetime_select :start %>
  </div>

  <div class="field">
    <%= form.label :end %>
    <%= form.datetime_select :end %>
  </div>

  <div class="field">
    <%= form.label :service %>
    <%= collection_select(:service_order, :service_id, Service.all, :id, :description) %>
  </div>

  <div class="field">
    <%= form.label :amount %>
    <%= form.number_field :amount %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/service_orders/edit.html.erb
<h1>Editing Service Order</h1>

<%= render 'form', service_order: @service_order %>

<%= link_to 'Show', @service_order %> |
<%= link_to 'Back', service_orders_path %>

app/views/service_orders/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Service Orders</h1>

<table>
  <thead>
    <tr>
      <th>Employee</th>
      <th>Detail</th>
      <th>Date</th>
      <th>Start</th>
      <th>End</th>
      <th>Service</th>
      <th>Amount</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @service_orders.each do |service_order| %>
      <tr>
        <td><%= service_order.employee %></td>
        <td><%= service_order.detail %></td>
        <td><%= service_order.date %></td>
        <td><%= service_order.start %></td>
        <td><%= service_order.end %></td>
        <td><%= service_order.service.description %></td>
        <td><%= service_order.amount %></td>
        <td><%= link_to 'Show', service_order %></td>
        <td><%= link_to 'Edit', edit_service_order_path(service_order) %></td>
        <td><%= link_to 'Destroy', service_order, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Service Order', new_service_order_path %>

app/views/service_orders/new.html.erb
<h1>New Service Order</h1>

<%= render 'form', service_order: @service_order %>

<%= link_to 'Back', service_orders_path %>

app/views/service_orders/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Employee:</strong>
  <%= @service_order.employee %>
</p>

<p>
  <strong>Detail:</strong>
  <%= @service_order.detail %>
</p>

<p>
  <strong>Date:</strong>
  <%= @service_order.date %>
</p>

<p>
  <strong>Start:</strong>
  <%= @service_order.start %>
</p>

<p>
  <strong>End:</strong>
  <%= @service_order.end %>
</p>

<p>
  <strong>Amount:</strong>
  <%= @service_order.amount %>
</p>

<%= link_to 'Edit', edit_service_order_path(@service_order) %> |
<%= link_to 'Back', service_orders_path %>

app/views/services/_form.html.erb
<%= form_with(model: service, local: true) do |form| %>
  <% if service.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(service.errors.count, "error") %> prohibited this service from being saved:</h2>

      <ul>
        <% service.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :description %>
    <%= form.text_field :description %>
  </div>

  <div class="field">
    <%= form.label :value %>
    <%= form.text_field :value %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/services/edit.html.erb
<h1>Editing Service</h1>

<%= render 'form', service: @service %>

<%= link_to 'Show', @service %> |
<%= link_to 'Back', services_path %>

app/views/services/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Services</h1>

<table>
  <thead>
    <tr>
      <th>Description</th>
      <th>Value</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @services.each do |service| %>
      <tr>
        <td><%= service.description %></td>
        <td><%= service.value %></td>
        <td><%= link_to 'Show', service %></td>
        <td><%= link_to 'Edit', edit_service_path(service) %></td>
        <td><%= link_to 'Destroy', service, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Service', new_service_path %>

app/views/services/new.html.erb
<h1>New Service</h1>

<%= render 'form', service: @service %>

<%= link_to 'Back', services_path %>

app/views/services/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Description:</strong>
  <%= @service.description %>
</p>

<p>
  <strong>Value:</strong>
  <%= @service.value %>
</p>

<%= link_to 'Edit', edit_service_path(@service) %> |
<%= link_to 'Back', services_path %>